<?php defined('SYSPATH') or die('No direct script access.');
class Products_Model extends Model
{
	public function __construct()
	{
		parent::__construct();
		$this->db = new Database();
		$this->session = Session::instance();
		$this->city_id = $this->session->get("CityID");
		$this->UserID = $this->session->get("UserID");
	}
	 
	/** PRODUCTS COUNT **/

	public function get_products_count($search = "",$category = "",$cur_category="",$cur_size="")
	{
        $conditions = "";
			$join ="join category on category.category_id=product.category_id";
		if($cur_category){
			$conditions = "and category.category_id IN ($cur_category)";
				}
		if($cur_size){
			$conditions = "and product_size.size_id IN ($cur_size) and product_size.quantity!=0";
				}
		if($category){
			 $conditions = " and category.category_url='$category'";
		}
		if($search=='sub'){
			$conditions = " AND category_mapping.category_type = 2 and category.category_url='$category'";
			$join ="join category_mapping ON category_map_deal_id = product.deal_id join category on category.category_id=map_category_id";
		}
		if($search!='main' && $search!='sub'){
			 $conditions .= " and (deal_title like '%".mysql_escape_string($search)."%'";
			 $conditions .= " or deal_description like '%".mysql_escape_string($search)."%')";
		}
		if(CITY_SETTING){ 
		$query = "select product.deal_id from product join product_size on product_size.deal_id=product.deal_id $join where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 $conditions group by product.deal_id order by product.deal_id DESC";
		$result = $this->db->query($query);
	        return count($result);
		} else { 
			$query = "select product.deal_id from product join product_size on product_size.deal_id=product.deal_id $join where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 $conditions group by product.deal_id order by product.deal_id DESC";
			$result = $this->db->query($query);
			
	        return count($result);
		}
	}
       
	/** GET PRODUCTS LIST **/

	public function  get_products_list($search = "", $category = "", $offset = "", $record = "",$cur_category="",$cur_size="")
	{
	        $conditions = "";
			
		$join ="join category on category.category_id=product.category_id";
		if($cur_category){
			$conditions = "and category.category_id IN ($cur_category)";
				}
		if($cur_size){
			$conditions = "and product_size.size_id IN ($cur_size) and product_size.quantity!=0";
				}
		if($category){
			 $conditions = " and category.category_url='$category'";
		}
		if($search=='sub'){
			$conditions = " AND category_mapping.category_type = 2 and category.category_url='$category'";
			$join ="join category_mapping ON category_map_deal_id = product.deal_id join category on category.category_id=map_category_id";
		}
		
		if($search!='main' && $search!='sub'){
			
			 $conditions .= " and (deal_title like '%".mysql_escape_string($search)."%'";
			 $conditions .= " or deal_description like '%".mysql_escape_string($search)."%')";
		}
		if(CITY_SETTING){ 
		$query = "select * from product $join join product_size on product_size.deal_id=product.deal_id where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 $conditions group by product.deal_id order by product.deal_id DESC limit $offset,$record"; 
		$result = $this->db->query($query);
	       
	        return $result;
		} else {
			
			$query = "select * from product $join join product_size on product_size.deal_id=product.deal_id where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 $conditions  group by product.deal_id order by product.deal_id DESC limit $offset,$record"; 
			$result = $this->db->query($query);
			
	        return $result;
		} 
	}

	/** VIEW PRODUCTS **/
	
	public function get_product_details($deal_key = "", $url_title = "",$type = "")
	{
			if($type == "admin" ){
				$condition = array("url_title" => $url_title, "deal_key" => $deal_key,"category.category_status" => 1);
			}
			else{
				$condition = array("url_title" => $url_title, "deal_key" => $deal_key,"deal_status" => 1, "category.category_status" => 1);
			}
	        $result = $this->db->select("*")->from("product")
	                        ->where($condition)
				            ->join("category","category.category_id","product.category_id")
 	                        ->get();
                
                return $result;
	}

	/** GET RELATED CATEGORY DEALS LIST  **/
	
	public function get_related_category_products_list($deal_id = "", $category_id = "")
	{
		$result = $this->db->query("select * from product join category on category.category_id=product.category_id where purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and deal_id <> '$deal_id' and product.category_id =  '$category_id'   order by deal_id DESC ");
	        return $result;
	}
	
	/** ADD COMMENTS **/

	public function add_comments($comments = "" , $deal_id = "")
	{
	        $result = $this->db->insert("discussion", array("user_id" =>$this->UserID, "deal_id" => $deal_id, "comments" => $comments, "created_date" => time()));
		
		return 0;
	}
	/** GET CART PRODUCTS LIST **/

	public function get_cart_products($deal_id = "")
	{                   
		$result = $this->db->from("product")->where(array("deal_id" => $deal_id))->get();
		return $result;
	}
	
	/** GET PRODUCT SIZE **/
	public function get_product_one_size($deal_id = "")
	{
		$result = $this->db->from("product_size")
				->where(array("deal_id" => $deal_id))
				 ->orderby("size_name","ASC")
		     		->get();
		return $result;
	}
	
	/** GET PRODUCT COLOR **/
	public function get_product_color($deal_id = "")
	{
		$result = $this->db->from("color")
				->where(array("deal_id" => $deal_id))
		     		->get();
		return $result;
	}
	
	/** PRODUCT STAR RATING **/
	
	public function save_product_rating($post="")
	{
		$result= $this->db->from("rating")->where(array("type_id" => $post->deal_id, "user_id" => $this->UserID))->get(); 
		if(count($result)==0)
		{
			$result = $this->db->insert("rating", array("type_id" => $post->deal_id, "user_id" => $this->UserID, "rating" => $post->rate, "module_id" => 2));
		}
		elseif(count($result)>0)
		{
			$result= $this->db->update("rating", array("rating" => $post->rate), array("type_id" => $post->deal_id, "user_id" => $this->UserID, "module_id" => 2));
		} 
	}

	/** AUCTION RATING **/
	
	public function get_product_rating($deal_id="")
	{
		$result= $this->db->from("rating")->where(array("type_id" => $deal_id))->get();
		if(count($result)>0)
		{
			$get_rate = count($result);
			$sum= $this->db->query("select sum(rating) as sum from rating where type_id=$deal_id AND module_id = 2");
			$get_sum=$sum->current()->sum;
			$average= $get_sum/$get_rate;
			return $average;
		}
		elseif(count($result)==0)
		{
			return 0;
		}
	}	
	
	/** GET PRODUCT COLOR **/
	
	public function get_color_data($deal_id = "")
	{
		$result = $this->db->from("color")
				->where(array("deal_id" => $deal_id))
		     		->get();
		return $result;
	}
	
	/** GET PRODUCT SIZE **/
	
	public function get_size_data($deal_id = "")
	{
		$result = $this->db->from("product_size")
				->where(array("deal_id" => $deal_id))
		     		->get();
		return $result;
	}

	       
	/** GET PRODUCTS LIST **/

	public function  get_products_min_max()
	{
		if(CITY_SETTING){ 
		$query = "select MAX(deal_value) as max_deal, MIN(deal_value) as min_deal from product join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 order by deal_id ASC "; 
		$result = $this->db->query($query);
	        return $result;
		} else {
			$query = "select MAX(deal_value) as max_deal, MIN(deal_value) as min_deal from product join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 order by deal_id ASC"; 
			$result = $this->db->query($query);
	        return $result;
		} 
	}

		 /** GET DEALS LIST BY FILTER */

	 public function get_products_lists_byfilter($price_from,$price_to)
	  {
		if(CITY_SETTING){
				$query = "select * from product join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and product.deal_value between $price_from and $price_to   order by deal_id ASC ";
				$result = $this->db->query($query);
				return $result;
		}
		else {
				if($price_from == 0)
				{
					$price_to = 100000;
				}
				$query = "select * from product join category on category.category_id=product.category_id where  deal_status = 1 and purchase_count < user_limit_quantity  and category.category_status = 1 and product.deal_value between $price_from and $price_to   order by deal_id ASC ";
				$result = $this->db->query($query);
				return $result;
		}
	  }

	/** GET PRODUCTS SUB CATEGORY LIST **/
	
	public function get_subcategory_list($id="")
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"main_category_id !="=>0,"main_category_id"=>$id))->orderby("category_name","ASC")->get();
		return $result;
	}
		
	/** GET COLOR LIST 
	
	public function get_color_list()
	{
		return $this->db->get('color_code');

	} **/
		/** GET COLOR LIST  **/
	
	public function get_size_list()
	{
		return $this->db->get('size');
	}
	
	/** GET DEALS LIST BY COLOR FILTER */

	 public function get_products_lists_bycolor($color="")
	  {
		if(CITY_SETTING){
				$query = "select * from product join color on color.deal_id=product.deal_id join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and color.color_id = $color order by product.deal_id ASC ";
				$result = $this->db->query($query);
				return $result;
		}
		else {
				$query = "select * from product join color on color.deal_id=product.deal_id join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and color.color_id = $color  order by product.deal_id ASC";
				$result = $this->db->query($query);
				return $result;
		}
	  }
	/** GET DEALS LIST BY COLOR FILTER */

	 public function get_products_lists_bycolor_count($color="")
	  {
		if(CITY_SETTING){
				$query = "select * from product join color on color.deal_id=product.deal_id join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and color.color_id = $color order by product.deal_id ASC ";
				$result = $this->db->query($query);
				return count($result);
		}
		else {
				$query = "select * from product join color on color.deal_id=product.deal_id join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and color.color_id = $color  order by product.deal_id ASC";
				$result = $this->db->query($query);
		 		return count($result);

		}
	  }

	/** GET DEALS LIST BY SIZE FILTER */

	 public function get_products_lists_bysize($size="")
	  {
		if(CITY_SETTING){
				$query = "select * from product join product_size on product_size.deal_id=product.deal_id join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and product_size.size_id = $size order by product.deal_id ASC ";
				$result = $this->db->query($query);
				return $result;
		}
		else {
				$query = "select * from product join product_size on product_size.deal_id=product.deal_id join category on category.category_id=product.category_id where  purchase_count < user_limit_quantity and deal_status = 1 and category.category_status = 1 and product_size.size_id = $size  order by product.deal_id ASC";
				$result = $this->db->query($query);
				return $result;
		}
	  }

	/** GET PRODUCT COLOR **/
	public function get_color_list()
	{
		$result = $this->db->from("color")
				->where(array("color_status" =>0))
				->groupby("color_name")
		     		->get();
		return $result;
	}

	/** GET DEALS SUB CATEGORY LIST **/
	
	public function get_maincate_name()
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"main_category_id !="=>0))->orderby("category_name","ASC")->get();
		return $result;
	}

	/** GET PRODUCTS SUB CATEGORY LIST **/
	
	public function get_main_category($category="")
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"category_url"=>$category))->orderby("category_name","ASC")->get();
		return $result;
	}
	/** GET PRODUCTS SUB CATEGORY LIST **/
	
	public function get_main_categoryname($category_id="")
	{
		$result = $this->db->from("category")->where(array("category_status" => 1,"category_id"=>$category_id))->orderby("category_name","ASC")->get();
		return $result;
	}
	
	/** GET COMMENTS LIST **/

	public function get_comments_data($deal_id = "",$type = "")
	{
                               
		$result = $this->db->from("discussion")
						   ->join("users","users.user_id","discussion.user_id")
						   ->where(array("deal_id" => $deal_id,"discussion_status" => "1","delete_status" => 1,"type" =>$type))->orderby("discussion_id", "DESC")->get();
		return $result;
	}
	
	/** GET LIKE COUNT **/
	
	public function get_like_data($deal_id = "",$type = "")
	{
		$result = $this->db->from('discussion_likes')->where(array('deal_id' => $deal_id,"type" =>$type))->get();
		return $result;
	}
	
	/** GET UNLIKE COUNT **/
	
	public function get_unlike_data($deal_id = "",$type = "")
	{
		$result = $this->db->from('discussion_unlike')->where(array('deal_id' => $deal_id,"type" =>$type))->get();
		return $result;
	}
	
		
}
